Index: romio/include/mpio.h.in
===================================================================
RCS file: /home/MPI/cvsMaster/romio/include/mpio.h.in,v
retrieving revision 1.20
retrieving revision 1.25
--- romio/include/mpio.h.in	7 Nov 2003 00:14:54 -0000	1.20
+++ romio/include/mpio.h.in	1 Jun 2004 19:21:16 -0000	1.25
@@ -1,40 +1,46 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: mpio.h.in,v 1.20 2003/11/07 00:14:54 robl Exp $    
+ *   $Id: mpio.h.in,v 1.25 2004/06/01 19:21:16 thakur Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 /* user include file for MPI-IO programs */
 
 #ifndef MPIO_INCLUDE
 #define MPIO_INCLUDE
 
 #include "mpi.h"
 
 #if defined(__cplusplus)
 extern "C" {
 #endif
 
-#define ROMIO_VERSION 124 /* version 1.2.4 */
+#define ROMIO_VERSION 126 /* version 1.2.6 */
 
 /* define MPI-IO datatypes and constants */
 
 #ifndef MPI_FILE_DEFINED
 typedef struct ADIOI_FileD *MPI_File;
 #endif
 
 @DEFINE_HAVE_MPI_GREQUEST@
 #ifndef HAVE_MPI_GREQUEST
 typedef struct ADIOI_RequestD *MPIO_Request;  
 #else
 #define MPIO_Request MPI_Request
+#define MPIO_USES_MPI_REQUEST
+/* Also rename the MPIO routines to get the MPI versions */
+#define MPIO_Wait MPI_Wait
+#define MPIO_Test MPI_Test
+#define PMPIO_Wait PMPI_Wait
+#define PMPIO_Test PMPI_Test
 #endif
 #define MPIO_REQUEST_DEFINED
 
 #ifndef HAVE_MPI_OFFSET
 @DEFINE_MPI_OFFSET@
 #endif
 
 #ifndef NEEDS_MPI_FINT
@@ -61,17 +67,22 @@
 #define MPI_MODE_EXCL               64  /* ADIO_EXCL */
 #define MPI_MODE_DELETE_ON_CLOSE    16  /* ADIO_DELETE_ON_CLOSE */
 #define MPI_MODE_UNIQUE_OPEN        32  /* ADIO_UNIQUE_OPEN */
 #define MPI_MODE_APPEND            128  /* ADIO_APPEND */
 #define MPI_MODE_SEQUENTIAL        256  /* ADIO_SEQUENTIAL */
 
 #define MPI_DISPLACEMENT_CURRENT   -54278278
 
+#ifndef MPI_FILE_NULL
+
+
+
 #define MPI_FILE_NULL           ((MPI_File) 0)
+#endif
 #define MPIO_REQUEST_NULL       ((MPIO_Request) 0)
 
 #define MPI_SEEK_SET            600
 #define MPI_SEEK_CUR            602
 #define MPI_SEEK_END            604
 
 #define MPI_MAX_DATAREP_STRING  128
 
@@ -199,18 +210,21 @@
                                      MPI_Aint *extent);
 
 /* Section 9.6.1 */
 int MPI_File_set_atomicity(MPI_File fh, int flag);
 int MPI_File_get_atomicity(MPI_File fh, int *flag);
 int MPI_File_sync(MPI_File fh);
 
 /* Section 4.13.3 */
+#ifndef MPICH2
+/* MPICH2 provides these definitions */
 int MPI_File_set_errhandler( MPI_File, MPI_Errhandler );
 int MPI_File_get_errhandler( MPI_File, MPI_Errhandler * );
+#endif
 /* End Prototypes */
 
 #ifndef HAVE_MPI_DARRAY_SUBARRAY
 /* Section 4.14.4 */
 int MPI_Type_create_subarray(int ndims, int *array_of_sizes, int
                       *array_of_subsizes, int *array_of_starts, int order, 
                       MPI_Datatype oldtype, MPI_Datatype *newtype);
 
@@ -394,18 +408,21 @@
                                       MPI_Aint *extent);
 
 /* Section 9.6.1 */
 int PMPI_File_set_atomicity(MPI_File fh, int flag);
 int PMPI_File_get_atomicity(MPI_File fh, int *flag);
 int PMPI_File_sync(MPI_File fh);
 
 /* Section 4.13.3 */
+#ifndef MPICH2
+/* MPICH2 provides these definitions */
 int PMPI_File_set_errhandler( MPI_File, MPI_Errhandler );
 int PMPI_File_get_errhandler( MPI_File, MPI_Errhandler * );
+#endif
 
 #ifndef HAVE_MPI_DARRAY_SUBARRAY
 /* Section 4.14.4 */
 int PMPI_Type_create_subarray(int ndims, int *array_of_sizes, int
                       *array_of_subsizes, int *array_of_starts, int order, 
                       MPI_Datatype oldtype, MPI_Datatype *newtype);
 
 /* Section 4.14.5 */
Index: romio/mpi-io/.cvsignore
===================================================================
RCS file: /home/MPI/cvsMaster/romio/mpi-io/.cvsignore,v
retrieving revision 1.2
retrieving revision 1.3
--- romio/mpi-io/.cvsignore	1 Aug 2003 13:30:20 -0000	1.2
+++ romio/mpi-io/.cvsignore	19 Jan 2004 14:49:37 -0000	1.3
@@ -1,2 +1,5 @@
 Makefile
 .deps
+*.o
+*.bb
+*.bbg
Index: romio/mpi-io/close.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/mpi-io/close.c,v
retrieving revision 1.11
retrieving revision 1.12
--- romio/mpi-io/close.c	1 Jul 2003 19:12:39 -0000	1.11
+++ romio/mpi-io/close.c	6 Apr 2004 18:46:31 -0000	1.12
@@ -1,11 +1,11 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: close.c,v 1.11 2003/07/01 19:12:39 robl Exp $    
+ *   $Id: close.c,v 1.12 2004/04/06 18:46:31 thakur Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "mpioimpl.h"
 
 #ifdef HAVE_WEAK_SYMBOLS
@@ -50,16 +50,20 @@
 	MPI_Abort(MPI_COMM_WORLD, 1);
     }
 #else
     ADIOI_TEST_FILE_HANDLE(*fh, myname);
 #endif
 
     if (((*fh)->file_system != ADIO_PIOFS) && ((*fh)->file_system != ADIO_PVFS) && ((*fh)->file_system != ADIO_PVFS2)) {
 	ADIOI_Free((*fh)->shared_fp_fname);
+        /* need a barrier because the file containing the shared file
+        pointer is opened with COMM_SELF. We don't want it to be
+	deleted while others are still accessing it. */ 
+        MPI_Barrier((*fh)->comm);
 	if ((*fh)->shared_fp_fd != ADIO_FILE_NULL)
 	    ADIO_Close((*fh)->shared_fp_fd, &error_code);
     }
 
     ADIO_Close(*fh, &error_code);
 
     *fh = MPI_FILE_NULL;
 #ifdef MPI_hpux
Index: romio/mpi-io/delete.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/mpi-io/delete.c,v
retrieving revision 1.18
retrieving revision 1.19
--- romio/mpi-io/delete.c	15 Sep 2003 13:33:30 -0000	1.18
+++ romio/mpi-io/delete.c	12 Feb 2004 06:08:22 -0000	1.19
@@ -1,11 +1,11 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: delete.c,v 1.18 2003/09/15 13:33:30 gropp Exp $    
+ *   $Id: delete.c,v 1.19 2004/02/12 06:08:22 David Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "mpioimpl.h"
 
 #ifdef HAVE_WEAK_SYMBOLS
@@ -51,26 +51,29 @@
 #endif /* MPI_hpux */
 
     /* first check if ADIO has been initialized. If not, initialize it */
     if (ADIO_Init_keyval == MPI_KEYVAL_INVALID) {
 
    /* check if MPI itself has been initialized. If not, flag an error.
    Can't initialize it here, because don't know argc, argv */
         MPI_Initialized(&flag);
-        if (!flag) {
+	/* --BEGIN ERROR HANDLING-- */
+        if (!flag)
+	{
 #ifdef MPICH2
 	    error_code = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, myname, __LINE__, MPI_ERR_INTERN, 
 					  "**initialized", 0);
 	    return MPIR_Err_return_file(MPI_FILE_NULL, myname, error_code);
 #else
             FPRINTF(stderr, "Error: MPI_Init() must be called before using MPI-IO\n");
             MPI_Abort(MPI_COMM_WORLD, 1);
 #endif
         }
+	/* --END ERROR HANDLING-- */
 
         MPI_Keyval_create(MPI_NULL_COPY_FN, ADIOI_End_call, &ADIO_Init_keyval,
                           (void *) 0);  
 
    /* put a dummy attribute on MPI_COMM_WORLD, because we want the delete
    function to be called when MPI_COMM_WORLD is freed. Hopefully the
    MPI library frees MPI_COMM_WORLD when MPI_Finalize is called,
    though the standard does not mandate this. */
@@ -81,30 +84,33 @@
 
         ADIO_Init( (int *)0, (char ***)0, &error_code);
     }
 
 
     /* resolve file system type from file name; this is a collective call */
     ADIO_ResolveFileType(MPI_COMM_SELF, filename, &file_system, &fsops, 
 			 &error_code);
-    if (error_code != MPI_SUCCESS) {
+    /* --BEGIN ERROR HANDLING-- */
+    if (error_code != MPI_SUCCESS)
+    {
 	/* ADIO_ResolveFileType() will print as informative a message as it
 	 * possibly can or call MPIR_Err_setmsg.  We just need to propagate 
 	 * the error up.  In the PRINT_ERR_MSG case MPI_Abort has already
 	 * been called as well, so we probably didn't even make it this far.
 	 */
 #ifdef MPICH2
 	return MPIR_Err_return_file(MPI_FILE_NULL, myname, error_code);
 #elif defined(PRINT_ERR_MSG)
 	MPI_Abort(MPI_COMM_WORLD, 1); /* this is mostly here for clarity */
 #else /* MPICH-1 */
 	return ADIOI_Error(MPI_FILE_NULL, error_code, myname);
 #endif
     }
+    /* --END ERROR HANDLING-- */
 
     /* skip prefix on filename if there is one */
     tmp = strchr(filename, ':');
     /* Only skip prefixes greater than length one to allow for windows drive specification (c:\...)*/
     /*if (tmp) filename = tmp + 1;*/
     if (tmp > filename + 1)
 	filename = tmp + 1;
 
Index: romio/mpi-io/get_posn_sh.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/mpi-io/get_posn_sh.c,v
retrieving revision 1.17
retrieving revision 1.18
--- romio/mpi-io/get_posn_sh.c	1 Jul 2003 19:12:39 -0000	1.17
+++ romio/mpi-io/get_posn_sh.c	12 Feb 2004 06:08:24 -0000	1.18
@@ -1,11 +1,11 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: get_posn_sh.c,v 1.17 2003/07/01 19:12:39 robl Exp $    
+ *   $Id: get_posn_sh.c,v 1.18 2004/02/12 06:08:24 David Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "mpioimpl.h"
 
 #ifdef HAVE_WEAK_SYMBOLS
@@ -47,42 +47,46 @@
     if ((fh <= (MPI_File) 0) || (fh->cookie != ADIOI_FILE_COOKIE)) {
 	FPRINTF(stderr, "MPI_File_get_position_shared: Invalid file handle\n");
 	MPI_Abort(MPI_COMM_WORLD, 1);
     }
 #else
     ADIOI_TEST_FILE_HANDLE(fh, myname);
 #endif
 
-    if (fh->access_mode & MPI_MODE_SEQUENTIAL) {
+    /* --BEGIN ERROR HANDLING-- */
+    if (fh->access_mode & MPI_MODE_SEQUENTIAL)
+    {
 #ifdef MPICH2
 	error_code = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, myname, __LINE__, MPI_ERR_UNSUPPORTED_OPERATION, 
 	    "**ioamodeseq", 0);
 	return MPIR_Err_return_file(fh, myname, error_code);
 #elif defined(PRINT_ERR_MSG)
         FPRINTF(stderr, "MPI_File_get_position_shared: Can't use this function because file was opened with MPI_MODE_SEQUENTIAL\n");
         MPI_Abort(MPI_COMM_WORLD, 1);
 #else /* MPICH-1 */
 	error_code = MPIR_Err_setmsg(MPI_ERR_UNSUPPORTED_OPERATION, MPIR_ERR_AMODE_SEQ,
 				     myname, (char *) 0, (char *) 0);
 	return ADIOI_Error(fh, error_code, myname);
 #endif
     }
 
-    if ((fh->file_system == ADIO_PIOFS) || (fh->file_system == ADIO_PVFS) || (fh->file_system == ADIO_PVFS2)) {
+    if ((fh->file_system == ADIO_PIOFS) || (fh->file_system == ADIO_PVFS) || (fh->file_system == ADIO_PVFS2))
+    {
 #ifdef MPICH2
 	error_code = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, myname, __LINE__, MPI_ERR_UNSUPPORTED_OPERATION, "**iosharedunsupported", 0);
 	return MPIR_Err_return_file(fh, myname, error_code);
 #elif defined(PRINT_ERR_MSG)
 	FPRINTF(stderr, "MPI_File_get_position_shared: Shared file pointer not supported on PIOFS and PVFS\n");
 	MPI_Abort(MPI_COMM_WORLD, 1);
 #else /* MPICH-1 */
 	error_code = MPIR_Err_setmsg(MPI_ERR_UNSUPPORTED_OPERATION, 
                     MPIR_ERR_NO_SHARED_FP, myname, (char *) 0, (char *) 0);
 	return ADIOI_Error(fh, error_code, myname);
 #endif
     }
+    /* --END ERROR HANDLING-- */
 
     ADIOI_TEST_DEFERRED(fh, "MPI_File_get_position_shared", &error_code);
 
     ADIO_Get_shared_fp(fh, 0, offset, &error_code);
     return error_code;
 }
Index: romio/mpi-io/get_view.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/mpi-io/get_view.c,v
retrieving revision 1.15
retrieving revision 1.16
--- romio/mpi-io/get_view.c	18 Apr 2003 20:15:08 -0000	1.15
+++ romio/mpi-io/get_view.c	12 Feb 2004 06:08:26 -0000	1.16
@@ -1,11 +1,11 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: get_view.c,v 1.15 2003/04/18 20:15:08 David Exp $    
+ *   $Id: get_view.c,v 1.16 2004/02/12 06:08:26 David Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "mpioimpl.h"
 
 #ifdef HAVE_WEAK_SYMBOLS
@@ -55,30 +55,33 @@
     if ((fh <= (MPI_File) 0) || (fh->cookie != ADIOI_FILE_COOKIE)) {
 	FPRINTF(stderr, "MPI_File_get_view: Invalid file handle\n");
 	MPI_Abort(MPI_COMM_WORLD, 1);
     }
 #else
     ADIOI_TEST_FILE_HANDLE(fh, myname);
 #endif
 
-    if (datarep <= (char *) 0) {
+    /* --BEGIN ERROR HANDLING-- */
+    if (datarep <= (char *) 0)
+    {
 #ifdef MPICH2
 	error_code = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, myname, __LINE__, MPI_ERR_ARG, 
 	    "**iodatarepnomem", 0);
 	return MPIR_Err_return_file(fh, myname, error_code);
 #elif defined(PRINT_ERR_MSG)
 	FPRINTF(stderr, "MPI_File_get_view: The user must allocate memory for datarep\n");
 	MPI_Abort(MPI_COMM_WORLD, 1);
 #else /* MPICH-1 */
 	error_code = MPIR_Err_setmsg(MPI_ERR_ARG, MPIR_ERR_DATAREP_ARG,
 				     myname, (char *) 0, (char *) 0);
 	return ADIOI_Error(fh, error_code, myname);
 #endif
     }
+    /* --END ERROR HANDLING-- */
 
     *disp = fh->disp;
     strcpy(datarep, "native");
 
     MPI_Type_get_envelope(fh->etype, &i, &j, &k, &combiner);
     if (combiner == MPI_COMBINER_NAMED) *etype = fh->etype;
     else {
         MPI_Type_contiguous(1, fh->etype, &copy_etype);
Index: romio/mpi-io/ioreq_f2c.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/mpi-io/ioreq_f2c.c,v
retrieving revision 1.10
retrieving revision 1.11
--- romio/mpi-io/ioreq_f2c.c	24 Feb 2003 23:52:08 -0000	1.10
+++ romio/mpi-io/ioreq_f2c.c	12 Feb 2004 06:08:27 -0000	1.11
@@ -1,11 +1,11 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: ioreq_f2c.c,v 1.10 2003/02/24 23:52:08 robl Exp $    
+ *   $Id: ioreq_f2c.c,v 1.11 2004/02/12 06:08:27 David Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "mpioimpl.h"
 
 #ifdef HAVE_WEAK_SYMBOLS
@@ -39,17 +39,19 @@
 MPIO_Request MPIO_Request_f2c(MPI_Fint request) {return((MPIO_Request)request);}
 #else
 MPIO_Request MPIO_Request_f2c(MPI_Fint request)
 {
 
 #ifndef INT_LT_POINTER
     return (MPIO_Request) request;
 #else
+    /* --BEGIN ERROR HANDLING-- */
     if (!request) return MPIO_REQUEST_NULL;
     if ((request < 0) || (request > ADIOI_Reqtable_ptr)) {
 	FPRINTF(stderr, "MPIO_Request_f2c: Invalid request\n");
 	MPI_Abort(MPI_COMM_WORLD, 1);
     }
+    /* --END ERROR HANDLING-- */
     return ADIOI_Reqtable[request];
 #endif
 }
 #endif
Index: romio/mpi-io/iread_sh.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/mpi-io/iread_sh.c,v
retrieving revision 1.20
retrieving revision 1.21
--- romio/mpi-io/iread_sh.c	1 Jul 2003 19:12:40 -0000	1.20
+++ romio/mpi-io/iread_sh.c	12 Feb 2004 06:08:29 -0000	1.21
@@ -1,11 +1,11 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: iread_sh.c,v 1.20 2003/07/01 19:12:40 robl Exp $    
+ *   $Id: iread_sh.c,v 1.21 2004/02/12 06:08:29 David Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "mpioimpl.h"
 
 #ifdef HAVE_WEAK_SYMBOLS
@@ -71,129 +71,152 @@
     int error_code, bufsize, buftype_is_contig, filetype_is_contig;
 #if defined(MPICH2) || !defined(PRINT_ERR_MSG)
     static char myname[] = "MPI_FILE_IREAD_SHARED";
 #endif
     int datatype_size, incr;
     ADIO_Status status;
     ADIO_Offset off, shared_fp;
 
+    /* --BEGIN ERROR HANDLING-- */
 #ifdef PRINT_ERR_MSG
-    if ((fh <= (MPI_File) 0) || (fh->cookie != ADIOI_FILE_COOKIE)) {
+    if ((fh <= (MPI_File) 0) || (fh->cookie != ADIOI_FILE_COOKIE))
+    {
 	FPRINTF(stderr, "MPI_File_iread_shared: Invalid file handle\n");
 	MPI_Abort(MPI_COMM_WORLD, 1);
     }
 #else
     ADIOI_TEST_FILE_HANDLE(fh, myname);
 #endif
 
-    if (count < 0) {
+    if (count < 0)
+    {
 #ifdef MPICH2
 	error_code = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, myname, __LINE__, MPI_ERR_ARG, "**iobadcount", 0);
 	return MPIR_Err_return_file(fh, myname, error_code);
 #elif defined(PRINT_ERR_MSG)
 	FPRINTF(stderr, "MPI_File_iread_shared: Invalid count argument\n");
 	MPI_Abort(MPI_COMM_WORLD, 1);
 #else /* MPICH-1 */
 	error_code = MPIR_Err_setmsg(MPI_ERR_ARG, MPIR_ERR_COUNT_ARG,
 				     myname, (char *) 0, (char *) 0);
 	return ADIOI_Error(fh, error_code, myname);
 #endif
     }
 
-    if (datatype == MPI_DATATYPE_NULL) {
+    if (datatype == MPI_DATATYPE_NULL)
+    {
 #ifdef MPICH2
 	error_code = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, myname, __LINE__, MPI_ERR_TYPE, 
 	    "**dtypenull", 0);
 	return MPIR_Err_return_file(fh, myname, error_code);
 #elif defined(PRINT_ERR_MSG)
         FPRINTF(stderr, "MPI_File_iread_shared: Invalid datatype\n");
         MPI_Abort(MPI_COMM_WORLD, 1);
 #else /* MPICH-1 */
 	error_code = MPIR_Err_setmsg(MPI_ERR_TYPE, MPIR_ERR_TYPE_NULL,
 				     myname, (char *) 0, (char *) 0);
 	return ADIOI_Error(fh, error_code, myname);	    
 #endif
     }
+    /* --END ERROR HANDLING-- */
 
     MPI_Type_size(datatype, &datatype_size);
 
-    if ((count*datatype_size) % fh->etype_size != 0) {
+    /* --BEGIN ERROR HANDLING-- */
+    if ((count*datatype_size) % fh->etype_size != 0)
+    {
 #ifdef MPICH2
 	error_code = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, myname, __LINE__, MPI_ERR_IO, 
 	    "**ioetype", 0);
 	return MPIR_Err_return_file(fh, myname, error_code);
 #elif defined(PRINT_ERR_MSG)
         FPRINTF(stderr, "MPI_File_iread_shared: Only an integral number of etypes can be accessed\n");
         MPI_Abort(MPI_COMM_WORLD, 1);
 #else /* MPICH-1 */
 	error_code = MPIR_Err_setmsg(MPI_ERR_IO, MPIR_ERR_ETYPE_FRACTIONAL,
 				     myname, (char *) 0, (char *) 0);
 	return ADIOI_Error(fh, error_code, myname);	    
 #endif
     }
 
-    if ((fh->file_system == ADIO_PIOFS) || (fh->file_system == ADIO_PVFS) || (fh->file_system == ADIO_PVFS2)) {
+    if ((fh->file_system == ADIO_PIOFS) || (fh->file_system == ADIO_PVFS) || (fh->file_system == ADIO_PVFS2))
+    {
 #ifdef MPICH2
 	error_code = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, myname, __LINE__, MPI_ERR_UNSUPPORTED_OPERATION, 
 	    "**iosharedunsupported", 0);
 	return MPIR_Err_return_file(fh, myname, error_code);
 #elif defined(PRINT_ERR_MSG)
 	FPRINTF(stderr, "MPI_File_iread_shared: Shared file pointer not supported on PIOFS and PVFS\n");
 	MPI_Abort(MPI_COMM_WORLD, 1);
 #else /* MPICH-1 */
 	error_code = MPIR_Err_setmsg(MPI_ERR_UNSUPPORTED_OPERATION, 
                     MPIR_ERR_NO_SHARED_FP, myname, (char *) 0, (char *) 0);
 	return ADIOI_Error(fh, error_code, myname);
 #endif
     }
+    /* --END ERROR HANDLING-- */
 
     ADIOI_Datatype_iscontig(datatype, &buftype_is_contig);
     ADIOI_Datatype_iscontig(fh->filetype, &filetype_is_contig);
 
     ADIOI_TEST_DEFERRED(fh, "MPI_File_iread_sh", &error_code);
 
     incr = (count*datatype_size)/fh->etype_size;
     ADIO_Get_shared_fp(fh, incr, &shared_fp, &error_code);
-    if (error_code != MPI_SUCCESS) {
+    /* --BEGIN ERROR HANDLING-- */
+    if (error_code != MPI_SUCCESS)
+    {
 	FPRINTF(stderr, "MPI_File_iread_shared: Error! Could not access shared file pointer.\n");
 	MPI_Abort(MPI_COMM_WORLD, 1);
     }
+    /* --END ERROR HANDLING-- */
 
     /* contiguous or strided? */
-    if (buftype_is_contig && filetype_is_contig) {
+    if (buftype_is_contig && filetype_is_contig)
+    {
     /* convert count and shared_fp to bytes */
 	bufsize = datatype_size * count;
 	off = fh->disp + fh->etype_size * shared_fp;
         if (!(fh->atomicity))
+	{
 	    ADIO_IreadContig(fh, buf, count, datatype, ADIO_EXPLICIT_OFFSET,
 			off, request, &error_code); 
-        else {
+	}
+        else
+	{
             /* to maintain strict atomicity semantics with other concurrent
               operations, lock (exclusive) and call blocking routine */
 
             *request = ADIOI_Malloc_request();
             (*request)->optype = ADIOI_READ;
             (*request)->fd = fh;
             (*request)->datatype = datatype;
             (*request)->queued = 0;
 	    (*request)->handle = 0;
 
             if (fh->file_system != ADIO_NFS)
+	    {
                 ADIOI_WRITE_LOCK(fh, off, SEEK_SET, bufsize);
+	    }
 
             ADIO_ReadContig(fh, buf, count, datatype, ADIO_EXPLICIT_OFFSET, off, 
                     &status, &error_code);  
 
             if (fh->file_system != ADIO_NFS)
+	    {
                 ADIOI_UNLOCK(fh, off, SEEK_SET, bufsize);
+	    }
 
             fh->async_count++;
             /* status info. must be linked to the request structure, so that it
                can be accessed later from a wait */
         }
     }
-    else ADIO_IreadStrided(fh, buf, count, datatype, ADIO_EXPLICIT_OFFSET,
+    else
+    {
+	ADIO_IreadStrided(fh, buf, count, datatype, ADIO_EXPLICIT_OFFSET,
 			   shared_fp, request, &error_code); 
+    }
 
     return error_code;
 }
 #endif
Index: romio/mpi-io/mpich2_fileutil.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/mpi-io/mpich2_fileutil.c,v
retrieving revision 1.12
retrieving revision 1.15
--- romio/mpi-io/mpich2_fileutil.c	3 Nov 2003 13:49:38 -0000	1.12
+++ romio/mpi-io/mpich2_fileutil.c	7 Jun 2004 14:55:17 -0000	1.15
@@ -12,22 +12,26 @@
    in a ROMIO File structure.  FIXME: These should be imported from a common
    header file that is also used in errhan/file_set_errhandler.c
  */
 int MPIR_ROMIO_Get_file_errhand( MPI_File, MPI_Errhandler * );
 int MPIR_ROMIO_Set_file_errhand( MPI_File, MPI_Errhandler );
 void MPIR_Get_file_error_routine( MPI_Errhandler, 
 				  void (**)(MPI_File *, int *, ...), 
 				  int * );
+struct MPID_Comm;
+int MPID_Abort( struct MPID_Comm *comm, int mpi_errno, int exit_code, char *error_msg );
 
 int MPIR_Err_return_file( MPI_File file_ptr, const char fcname[], int errcode )
 {
     MPI_Errhandler e;
     void (*c_errhandler)(MPI_File *, int *, ... );
     int  kind;   /* Error handler kind (see below) */
+    char error_msg[4096];
+    int len;
 
     /* First, check the nesting level */
     /*if (MPIR_Nest_value()) return errcode;*/ /* Is there any recursion in the MPI_File_... interface? */
 
     /* If the file pointer is not valid, we use the handler on
        MPI_FILE_NULL (MPI-2, section 9.7).  For now, this code assumes that 
        MPI_FILE_NULL has the default handler (return).  FIXME.  See
        below - the set error handler uses ADIOI_DFLT_ERR_HANDLER; 
@@ -53,35 +57,22 @@
     }
     else {
 	MPIR_Get_file_error_routine( e, &c_errhandler, &kind );
     }
 
     /* --BEGIN ERROR HANDLING-- */
     if (MPIR_Err_is_fatal(errcode) || kind == 0) 
     {
-	if (MPIR_Err_print_stack_flag)
-	{
-	    fprintf( stderr, "Fatal error (code 0x%08x) in %s():\n", errcode, fcname);
-	    MPIR_Err_print_stack(stderr, errcode);
-	}
-	else
-	{
-	    /* The default handler should try the following: Provide the rank 
-	       in comm_world.  If the process is not in comm world,
-	       use something else.  If the communicator exists and has a name, 
-	       provide that name */
-	    char msg[MPI_MAX_ERROR_STRING];
-
-	    MPIR_Err_get_string( errcode, msg );
-	    fprintf( stderr, "Fatal error (code 0x%08x) in %s(): %s\n", 
-		     errcode, fcname, msg);
-	}
-
-	MPID_Abort( 0, errcode, errcode); 
+	/* This file does not get the correct definitions for MPIU_Snprintf because it cannot include mpiimpl.h */
+	/* MPIU_Snprintf(error_msg, 4096, "Fatal error in %s: ", fcname); */
+	sprintf(error_msg, "Fatal error in %s: ", fcname);
+	len = (int)strlen(error_msg);
+	MPIR_Err_get_string(errcode, &error_msg[len], 4096-len, NULL);
+	MPID_Abort(NULL, MPI_SUCCESS, errcode, error_msg);
     }
     /* --END ERROR HANDLING-- */
     else if (kind == 2) {
 	(*c_errhandler)( &file_ptr, &errcode, 0 );
     }
     /* if kind == 1, just return */
 
     return errcode;
Index: romio/mpi-io/mpioprof.h
===================================================================
RCS file: /home/MPI/cvsMaster/romio/mpi-io/mpioprof.h,v
retrieving revision 1.9
retrieving revision 1.10
--- romio/mpi-io/mpioprof.h	8 Sep 2003 13:32:48 -0000	1.9
+++ romio/mpi-io/mpioprof.h	28 May 2004 23:05:41 -0000	1.10
@@ -1,11 +1,11 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: mpioprof.h,v 1.9 2003/09/08 13:32:48 gropp Exp $    
+ *   $Id: mpioprof.h,v 1.10 2004/05/28 23:05:41 David Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 /* 
    This header file converts all MPI_ names into PMPI_ names, for 
    building the profiling interface
@@ -135,18 +135,20 @@
 #if !defined(MPI_File_f2c) || defined(MPICH_RENAMING_MPI_FUNCS)
 #undef MPI_File_f2c
 #define MPI_File_f2c PMPI_File_f2c
 #undef MPI_File_c2f
 #define MPI_File_c2f PMPI_File_c2f
 #endif
 
 #undef MPIO_Test
+#undef PMPIO_Test
 #define MPIO_Test PMPIO_Test
 #undef MPIO_Wait
+#undef PMPIO_Wait
 #define MPIO_Wait PMPIO_Wait
 #undef MPIO_Testall
 #define MPIO_Testall PMPIO_Testall
 #undef MPIO_Waitall
 #define MPIO_Waitall PMPIO_Waitall
 #undef MPIO_Testany
 #define MPIO_Testany PMPIO_Testany
 #undef MPIO_Waitany
@@ -182,9 +184,16 @@
 #define MPI_Info_free PMPI_Info_free
 #undef MPI_Info_c2f
 #define MPI_Info_c2f PMPI_Info_c2f
 #undef MPI_Info_f2c
 #define MPI_Info_f2c PMPI_Info_f2c
 
 #endif
 
+#undef MPI_Grequest_start
+#define MPI_Grequest_start PMPI_Grequest_start
+#undef MPI_Grequest_complete
+#define MPI_Grequest_complete PMPI_Grequest_complete
+#undef MPI_Status_set_cancelled
+#define MPI_Status_set_cancelled PMPI_Status_set_cancelled
+
 #endif
Index: romio/mpi-io/mpiu_greq.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/mpi-io/mpiu_greq.c,v
retrieving revision 1.2
retrieving revision 1.3
--- romio/mpi-io/mpiu_greq.c	18 Mar 2003 17:19:17 -0000	1.2
+++ romio/mpi-io/mpiu_greq.c	28 May 2004 23:05:41 -0000	1.3
@@ -2,16 +2,22 @@
 /*
  *  (C) 2003 by Argonne National Laboratory.
  *      See COPYRIGHT in top-level directory.
  */
 #include <string.h>
 #include "mpioimpl.h"
 #include "mpiu_greq.h"
 
+#ifdef HAVE_WEAK_SYMBOLS
+/* Include mapping from MPI->PMPI */
+#define MPIO_BUILD_PROFILING
+#include "mpioprof.h"
+#endif
+
 int MPIU_Greq_query_fn(void *extra_state, MPI_Status *status)
 {
 	int foo;
 
 	/* can't touch user's MPI_ERROR, so hold it for a moment */
 	foo = status->MPI_ERROR;
 
 	/* get the status from the blocking operation */
